package com.bcxin.rbac.domain.repository.custom;

import com.bcxin.rbac.domain.entities.RbacCustomRoleUserEntity;
import com.bcxin.rbac.domain.repositories.custom.RbacCustomRoleUserRepository;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;
import java.util.Optional;


public interface RbacCustomRoleUserJpaRepository extends RbacCustomRoleUserRepository, JpaRepository<RbacCustomRoleUserEntity, Long> {

    @Query("select count(t.id) from RbacCustomRoleUserEntity t where  t.rbacRoleId = :rbacRoleId")
    long findCountByRbacRoleId(@Param("rbacRoleId") Long rbacRoleId);

    Optional<RbacCustomRoleUserEntity> findByRbacRoleIdAndTenantEmployeeId(Long rbacRoleId, String tenantEmployeeId);

    @Query("select t from RbacCustomRoleUserEntity t where  t.rbacRoleId = :rbacRoleId and t.tenantEmployeeId in (:employeeIdList)")
    List<RbacCustomRoleUserEntity> findListByRbacRoleIdAndEmployeeIdList(@Param("rbacRoleId") Long rbacRoleId,
                                                                         @Param("employeeIdList") List<String> employeeIdList);

    List<RbacCustomRoleUserEntity> findByRbacRoleId(Long rbacRoleId);
}